LTTNG-SNAPSHOT(1)

NAME
lttng-snapshot - Take LTTng snapshots and configure snapshot outputs

SYNOPSIS

Add a snapshot output:

lttng [GENERAL OPTIONS] snapshot add-output [--max-size=SIZE]
      [--name=NAME] [--session=SESSION]
      (--ctrl-url=URL --data-url=URL | URL)

Remove a snapshot output:

lttng [GENERAL OPTIONS] snapshot del-output [--session=SESSION]
      (ID | NAME)

List current snapshot outputs:

lttng [GENERAL OPTIONS] snapshot list-output [--session=SESSION]

Take a snapshot:

lttng [GENERAL OPTIONS] snapshot record [--max-size=SIZE]
      [--name=NAME] [--session=SESSION]
      (--ctrl-url=URL --data-url=URL | URL)

DESCRIPTION

The lttng snapshot command manages the snapshot outputs and takes snapshots.

A snapshot is a dump of the current sub-buffers of all the channels of a given tracing session. When a snapshot is taken, the memory dump is sent to the registered snapshot outputs.

The tracing session should be created in snapshot mode to make sure taking snapshots is allowed. This is done at tracing session creation time using the lttng-create(1) command.

Note that, when a snapshot is taken, the sub-buffers are not cleared. This means that different recorded snapshots may contain the same events.

  Snapshot outputs

Snapshot outputs are the destinations of snapshot files when a snapshot is taken using the record action.

As of this version, only one snapshot output is allowed.

A snapshot output can be added using the add-output action. The output destination URL is set using either the URL positional argument, or both the --ctrl-url and --data-url options. See lttng-create(1) to learn more about the URL format.

A name can be assigned to an output when adding it using the --name option. This name is part of the names of the snapshot files written to this output.

By default, the snapshot files can be as big as the sum of the sizes of all the sub-buffers or all the channels of the selected tracing session. The maximum total size of all the snapshot files can be configured using the --max-size option.

Snapshot outputs can be listed using the list-output action.

Snapshot outputs can be removed using the del-output action. The configured name can be used when removing an output, or an ID as listed by the list-output action.

  Taking a snapshot

Taking a snapshot of the current tracing session is as easy as:

    $ lttng snapshot record

This writes the snapshot files to the configured output. It is possible to use a custom, unregistered output at record time using the same options supported by the add-output action.

    Note

    Before taking a snapshot on a system with a high event throughput, it is recommended to first run lttng stop (see lttng-stop(1)). Otherwise, the snapshot could contain "holes", the result of the tracers overwriting unconsumed trace packets during the record operation. After the snapshot is recorded, the tracers can be started again with lttng start (see lttng-start(1)).

OPTIONS

General options are described in lttng(1).

  Target

-s SESSION, --session=SESSION
    Take a snapshot of the sub-buffers of the channels contained in the tracing session named SESSION instead of the current tracing session.

  Snapshot output

-C URL, --ctrl-url=URL
    Set control path URL to URL (must use --data-url option also).

-D URL, --data-url=URL
    Set data path URL to URL (must use --ctrl-url option also).

-m SIZE, --max-size=SIZE
    Limit the total size of all the snapshot files written when recording a snapshot to SIZE bytes. The k (kiB), M (MiB), and G (GiB) suffixes are supported.

-n NAME, --name=NAME
    Assign the name NAME to the snapshot output.

  Program information

-h, --help
    Show command help.

    This option, like lttng-help(1), attempts to launch /usr/bin/man to view the command’s man page. The path to the man pager can be overridden by the LTTNG_MAN_BIN_PATH environment variable.

--list-options
    List available command options.

ENVIRONMENT VARIABLES

LTTNG_ABORT_ON_ERROR
    Set to 1 to abort the process after the first error is encountered.

LTTNG_HOME
    Overrides the $HOME environment variable. Useful when the user running the commands has a non-writable home directory.

LTTNG_MAN_BIN_PATH
    Absolute path to the man pager to use for viewing help information about LTTng commands (using lttng-help(1) or lttng COMMAND --help).

LTTNG_SESSION_CONFIG_XSD_PATH
    Path in which the session.xsd session configuration XML schema may be found.

LTTNG_SESSIOND_PATH
    Full session daemon binary path.

    The --sessiond-path option has precedence over this environment variable.

Note that the lttng-create(1) command can spawn an LTTng session daemon automatically if none is running. See lttng-sessiond(8) for the environment variables influencing the execution of the session daemon.

FILES

$LTTNG_HOME/.lttngrc
    User LTTng runtime configuration.

    This is where the per-user current tracing session is stored between executions of lttng(1). The current tracing session can be set with lttng-set-session(1). See lttng-create(1) for more information about tracing sessions.

$LTTNG_HOME/lttng-traces
    Default output directory of LTTng traces. This can be overridden with the --output option of the lttng-create(1) command.

$LTTNG_HOME/.lttng
    User LTTng runtime and configuration directory.

$LTTNG_HOME/.lttng/sessions
    Default location of saved user tracing sessions (see lttng-save(1) and lttng-load(1)).

/usr/local/etc/lttng/sessions
    System-wide location of saved tracing sessions (see lttng-save(1) and lttng-load(1)).

    Note

    $LTTNG_HOME defaults to $HOME when not explicitly set.

EXIT STATUS

0
    Success

1
    Command error

2
    Undefined command

3
    Fatal error

4
    Command warning (something went wrong during the command)

BUGS

If you encounter any issue or usability problem, please report it on the LTTng bug tracker <https://bugs.lttng.org/projects/lttng-tools>.

RESOURCES

    • LTTng project website <http://lttng.org>

    • LTTng documentation <http://lttng.org/docs>

    • Git repositories <http://git.lttng.org>

    • GitHub organization <http://github.com/lttng>

    • Continuous integration <http://ci.lttng.org/>

    • Mailing list <http://lists.lttng.org> for support and development: lttng-dev@lists.lttng.org

    • IRC channel <irc://irc.oftc.net/lttng>: #lttng on irc.oftc.net

COPYRIGHTS

This program is part of the LTTng-tools project.

LTTng-tools is distributed under the GNU General Public License version 2 <http://www.gnu.org/licenses/old-licenses/gpl-2.0.en.html>. See the LICENSE <https://github.com/lttng/lttng-tools/blob/master/LICENSE> file for details.

THANKS

Special thanks to Michel Dagenais and the DORSAL laboratory <http://www.dorsal.polymtl.ca/> at École Polytechnique de Montréal for the LTTng journey.

Also thanks to the Ericsson teams working on tracing which helped us greatly with detailed bug reports and unusual test cases.

AUTHORS

LTTng-tools was originally written by Mathieu Desnoyers, Julien Desfossez, and David Goulet. More people have since contributed to it.

LTTng-tools is currently maintained by Jérémie Galarneau <mailto:jeremie.galarneau@efficios.com>.

SEE ALSO

lttng(1)